/**
 * SubscriberCache.java:This is utility class to hold subscriber details.
 *
 */

package com.tsky.selfcare.util.jcache;

import org.apache.log4j.Logger;
import org.infinispan.Cache;
import org.infinispan.manager.CacheManager;
import org.infinispan.manager.DefaultCacheManager;

public class SubscriberCache {

	private static Logger log = Logger.getLogger(SubscriberCache.class);


	private static SubscriberCache singleInstance;
	private static CacheManager manager;
	private Cache someNamedCache;
    //Default constructor
	private SubscriberCache() {
	}

	// This method to get the instance of subscriber cache object
	public static SubscriberCache getSubscriberCacheInstance() {
		log.info("Entered SubscriberCache.getSubscriberCacheInstance");
		try {
			if (singleInstance == null) {
				// Creating subscriber cache
				singleInstance = new SubscriberCache();
			}
		}
		catch(Exception e) {
			log.error("Exception in create instance of SubscriberCache",e);
		}
		log.info("Exit SubscriberCache.getSubscriberCacheInstance");
		return singleInstance;
	}

	public Cache  startCache() {
		log.info("Entered SubscriberCache.startCache");
		try {
			if(manager==null)
			{
				manager = new DefaultCacheManager("config-file.xml");
				someNamedCache=manager.getCache("evictionCache");
				someNamedCache.start();
				log.info("Starting the Pojo Cache service for the first time");
			}
		}
		catch(Exception e) {
			log.error("Exception in create instance of SubscriberCache",e);
		}
		log.info("Exit SubscriberCache.startCache");
		return someNamedCache;
	}


}
